// Auto-generated. Do not edit!

// (in-package handle_detector.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let CylinderArrayMsg = require('./CylinderArrayMsg.js');
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class HandleListMsg {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.handles = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('handles')) {
        this.handles = initObj.handles
      }
      else {
        this.handles = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type HandleListMsg
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [handles]
    // Serialize the length for message field [handles]
    bufferOffset = _serializer.uint32(obj.handles.length, buffer, bufferOffset);
    obj.handles.forEach((val) => {
      bufferOffset = CylinderArrayMsg.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type HandleListMsg
    let len;
    let data = new HandleListMsg(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [handles]
    // Deserialize array length for message field [handles]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.handles = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.handles[i] = CylinderArrayMsg.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    object.handles.forEach((val) => {
      length += CylinderArrayMsg.getMessageSize(val);
    });
    return length + 4;
  }

  static datatype() {
    // Returns string type for a message object
    return 'handle_detector/HandleListMsg';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '026825e25bd6a57338f36ff3f9159754';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # A list of cylinders with a header.
    
    Header header
    
    handle_detector/CylinderArrayMsg[] handles
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    # 0: no frame
    # 1: global frame
    string frame_id
    
    ================================================================================
    MSG: handle_detector/CylinderArrayMsg
    # A list of cylinders with a header.
    
    Header header
    
    handle_detector/CylinderMsg[] cylinders
    
    ================================================================================
    MSG: handle_detector/CylinderMsg
    # A cylinder with its pose, radius, and extent.
    
    geometry_msgs/Pose pose
    
    float32 radius
    
    float32 extent
    
    # curvature axis (direction vector)
    geometry_msgs/Vector3 axis
     
    # normal axis (direction vector)
    geometry_msgs/Vector3 normal
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    ================================================================================
    MSG: geometry_msgs/Vector3
    # This represents a vector in free space. 
    # It is only meant to represent a direction. Therefore, it does not
    # make sense to apply a translation to it (e.g., when applying a 
    # generic rigid transformation to a Vector3, tf2 will only apply the
    # rotation). If you want your data to be translatable too, use the
    # geometry_msgs/Point message instead.
    
    float64 x
    float64 y
    float64 z
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new HandleListMsg(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.handles !== undefined) {
      resolved.handles = new Array(msg.handles.length);
      for (let i = 0; i < resolved.handles.length; ++i) {
        resolved.handles[i] = CylinderArrayMsg.Resolve(msg.handles[i]);
      }
    }
    else {
      resolved.handles = []
    }

    return resolved;
    }
};

module.exports = HandleListMsg;
